import java.awt.Canvas;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.BevelBorder;
import javax.swing.table.TableColumnModel;
import javax.swing.JTextField;
import javax.swing.JLabel;
import java.awt.event.InputMethodListener;
import java.awt.event.InputMethodEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Toolkit;


public class mainFrame {

	private JFrame frmFourierSignals;
	private JPanel pGraph;
	private TDataGrid tableData;
	private JTable tDataTable;
	private JComboBox comboBox;
	private JLabel lAlpha;
	private JLabel lNInput;
	private JTextField tbDegreInp;
	private JTextField tbN;
	
	public TComplex[] we;
	public TComplex[] w;
	public TComplex[] y;
	public TComplex[] c;
	boolean[] showDegrInput = { false, false, false, true, true, true, false, false, false, false, false };
	boolean[] showNInput = { false, false, false, false, false, false, true, true, true, true, true };

	double peak = 1.0;
	double alpha = 60 * Math.PI / 180.0;
	int n = 4;
	int order = 1001;
    
	
	public class myCanvas extends Canvas {
    	
		private static final long serialVersionUID = 1L;
		
		public void paint(Graphics g) { 		 			              
    		 drawGraph(g);
		}
	}
	
     
	private void Rectangle(double peak, double alpha, int n)
	{
		int j;
		c[0].real = 0;
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			c[j].real = 0;
			if (j % 2 == 0)
				c[j].imag = 0;
			else
				c[j].imag = peak * 4 / Math.PI / j;
		}
	}

	void Triangle(double peak, double alpha, int n)
	{
		int j;
		double sign = 1.0;
		c[0].real = 0;
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			c[j].real = 0;
			if (j % 2 == 0)
				c[j].imag = 0;
			else
			{
				c[j].imag = sign * peak * 8 / Math.PI / Math.PI / j / j;
				sign = -sign;
			}
		}
	}

	
	void Sawtooth(double peak, double alpha, int n)
	{
		int j;
		c[0].real = peak/2.0;
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			c[j].imag = 0;
			if (j % 2 == 0)
			{
				c[j].real = 0;
				c[j].imag = -peak * 2.0 / Math.PI / j;
			}
			else
			{
				c[j].real = 0; 
				c[j].imag = 0;
			}
		}
	}

	
	private void SinusRectifiedCut(double peak, double alpha, int n)
	{
		int j;
		c[0].real = peak / Math.PI * (1.0 + Math.cos(alpha));
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			if (j % 2 != 0)
			{
				c[j].real = 0;
				c[j].imag = 0;
			}
			else
			{
				c[j].real = peak / Math.PI * (Math.cos(alpha * (1.0 - j)) / (1.0 - j) + Math.cos(alpha * (1.0 + j)) / (1.0 + j) + 2.0 / (1.0 - j * j));
				c[j].imag = peak / Math.PI * (Math.sin(alpha * (1.0 + j)) / (1.0 + j) - Math.sin(alpha * (1.0 - j)) / (1.0 - j));
			}
		}
	}


	void SinusCut(double peak, double alpha, int n)
	{
		int j;
		c[0].real = 0;
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			if (j % 2 == 0)
			{
				c[j].real = 0;
				c[j].imag = 0;
			}
			else
			{
				if (j == 1)
				{
					c[j].real = peak / Math.PI / 2.0 * (Math.cos(2.0 * alpha) - 1.0);
					c[j].imag = peak / Math.PI / 2.0 * (2.0 * (Math.PI - alpha) + Math.sin(2.0 * alpha));
				}
				else
				{
					c[j].real = peak / Math.PI * (Math.cos(alpha * (1.0 - j)) / (1.0 - j) + Math.cos(alpha * (1.0 + j)) / (1.0 + j) - 2.0 / (1.0 - j * j));
					c[j].imag = peak / Math.PI * (Math.sin(alpha * (1.0 + j)) / (1.0 + j) - Math.sin(alpha * (1.0 - j)) / (1.0 - j));
				}
			}
		}
	}


	void Pwm(double peak, double alpha, int n)
	{
		int j;
		c[0].real = peak * alpha / Math.PI;
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			if (j % 2 == 0)
			{
				c[j].real = 2.0 * peak / Math.PI / j * Math.sin(j * alpha);
				c[j].imag = 2.0 * peak / Math.PI / j * (1.0 - Math.cos(j * alpha)); 
			}
			else
			{
				c[j].real = 0;
				c[j].imag = 0;
			}
		}
	}


	void Ask(double peak, double alpha, int n)
	{
		int j;
		c[0].real = 0;  
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			c[j].imag = 0;
			if ((n+j) % 2 == 0)
			{
				c[j].real = 0;
			}
			else
			{
				if (j != n)
					c[j].real = peak / Math.PI * 2.0 * (double)n / ((double)n * (double)n - (double)j * (double)j);
				else
					c[j].real = 0;
			}
		}
		c[n].imag = peak/2;
		if (n % 2 != 0)
			c[0].real = peak / Math.PI / (double)n;
	}


	void Fsk(double peak, double alpha, int n)
	{
		int j;
		c[0].real = 0;
		c[0].imag = 0;
		for (j = 1; j < 500; j++)
		{
			c[j].imag = 0;
			if ((n + j) % 2 == 0)
				c[j].real = 0;
			else
			{
				if (j != n)
					c[j].real = peak / Math.PI * (2.0 * (double)n / ((double)n * (double)n - (double)j * (double)j));
				else
					c[j].real = 0;
			}
			if ((j != 2) && ((j) % 2 != 0))
				c[j].real = c[j].real - peak / Math.PI * (4.0 / (4.0 - (double)j * (double)j));
		}
		c[2].imag = peak / 2.0;
         if (n == 2)
         {
             c[n].imag = peak;
             c[n].real = 0;
         }
         else
         {
             c[n].imag = peak / 2.0;
         }
     }


     void Psk180(double peak, double alpha, int n)
     {
         int j;
         c[0].real = 0;
         c[0].imag = 0;
         for (j = 1; j < 500; j++)
         {
             c[j].imag = 0;
             if ((n + j) % 2 == 0)
                   c[j].real = 0;
             else
             {
                 if (j != n)
                     c[j].real = peak / Math.PI * 4.0 * (double)n / ((double)n * (double)n - (double)j * (double)j);
                 else
                     c[j].real = 0;
             }
         }
     }


     void Psk270(double peak, double alpha, int n)
     {
         int j;
         c[0].real = 0;
         c[0].imag = 0;
         for (j = 1; j < 500; j++)
         {
             c[j].imag = 0;
             {
                 if (j != n)
                 {
                     if ((n + j) % 2 == 0)
                     {
                         c[j].real = 0;
                         c[j].imag = 0;
                     }
                     else
                     {
                         c[j].real = peak / Math.PI * 2.0 * (double)n / ((double)n * (double)n - (double)j * (double)j);
                         c[j].imag = -peak / Math.PI * 2.0 * (double)j / ((double)n * (double)n - (double)j * (double)j);
                     }
                 }
                 else
                 {
                     c[j].real = -peak * 0.5;
                     c[j].imag = peak * 0.5;
                 }
             }
         }
     }


     void Psk90(double peak, double alpha, int n)
     {
         int j;
         c[0].real = 0;
         c[0].imag = 0;
         for (j = 1; j < 500; j++)
         {
             c[j].imag = 0;
             {
                 if (j != n)
                 {
                     if ((n + j) % 2 == 0)
                     {
                         c[j].real = 0;
                         c[j].imag = 0;
                     }
                     else
                     {
                         c[j].real = peak / Math.PI * 2.0 * (double)n / ((double)n * (double)n - (double)j * (double)j);
                         c[j].imag = peak / Math.PI * 2.0 * (double)j / ((double)n * (double)n - (double)j * (double)j);
                     }
                 }
                 else
                 {
                     c[j].real = peak * 0.5;
                     c[j].imag = peak * 0.5;
                 }
             }
         }
     }

	
	 public void  drawGraph(Graphics g)
	 {
		 Point p1, p2;
		 int i, j;
		 p1 = new Point();
		 p2 = new Point();
		 double y1, y2;
		 double peak = pGraph.getHeight() / 2.5;
                 
		 p1.y = (pGraph.getHeight() / 2);
		 p2.x = pGraph.getWidth();
		 p2.y = (pGraph.getHeight() / 2);
		 g.setColor(new Color(0, 0, 0));
		 g.drawLine((int)Math.round(p1.x),(int)Math.round(p1.y),(int)Math.round( p2.x),(int)Math.round(p2.y)); 
		 if (order > 0)
		 {
			 for (j = 0; j < order - 1; j++)
			 {
				 p1.x = ((int)Math.round(j) * (pGraph.getWidth() - 40) / order) + 20;
				 p1.y = (pGraph.getHeight() / 2) - (int)Math.round(y[j].real * 5.0);
				 p2.x = ((int)Math.round(j + 1) * (pGraph.getWidth() - 40) / order) + 20;
				 p2.y = (pGraph.getHeight() / 2) - (int)Math.round(y[j + 1].real * 5.0);
             
				 y1 = 0;
				 y2 = 0;
				 for (i = 0; i < 400; i++)
				 {
					 y1 = y1 + (c[i].real * Math.cos(2.0 * Math.PI * (double)(i * j) / (double)(order)) +
							 c[i].imag * Math.sin(2.0 * Math.PI * (double)(i * j) / (double)(order)));
					 y2 = y2 + (c[i].real * Math.cos(2.0 * Math.PI * (double)(i * (j + 1)) / (double)(order)) +
							 c[i].imag * Math.sin(2.0 * Math.PI * (double)(i * (j + 1)) / (double)(order)));
				 }
				 p1.y = (pGraph.getHeight() / 2) - (int)Math.round(y1 * peak);
				 p2.y = (pGraph.getHeight() / 2) - (int)Math.round(y2 * peak);
				 g.setColor(new Color(0, 0, 255));
				 g.drawLine((int)Math.round(p1.x),(int)Math.round(p1.y),(int)Math.round( p2.x),(int)Math.round(p2.y)); 
			 }
		 }
	 }

	    
	 private void SelectionChanged()
	 {
		 int i;
		 switch(comboBox.getSelectedIndex())
	    	{
	    	case 0: Rectangle(peak, alpha, n);  
	    	break;
	    	case 1: Triangle(peak, alpha, n);  
	    	break;
	    	case 2: Sawtooth(peak, alpha, n);  
	    	break;
	    	case 3: SinusRectifiedCut(peak, alpha, n);  
	    	break;
	    	case 4: SinusCut(peak, alpha, n);  
	    	break;
	    	case 5: Pwm(peak, alpha, n);  
	    	break;
	    	case 6: Ask(peak, alpha, n);  
	    	break;
	    	case 7: Fsk(peak, alpha, n);  
	    	break;
	    	case 8: Psk270(peak, alpha, n);  
	    	break;
	    	case 9: Psk180(peak, alpha, n);  
	    	break;
	    	case 10: Psk90(peak, alpha, n);  
	    	break;
	    	}
		  if(comboBox.getSelectedIndex() >= 0)
		  {
			  tbDegreInp.setVisible(showDegrInput[comboBox.getSelectedIndex()]);
			  tbN.setVisible(showNInput[comboBox.getSelectedIndex()]);
			  lAlpha.setVisible(showDegrInput[comboBox.getSelectedIndex()]);
              lNInput.setVisible(showNInput[comboBox.getSelectedIndex()]);
		  }
          
		 for (i = 0; i < 30; i++)        // put values into the DataGrid
	        {
	        	 String str = Integer.toString(i);
	             tableData.setValueAt(str, i, 0);
	             str = Double.toString(Math.round(c[i].real*10000)/10000.0);
	             tableData.setValueAt(str, i, 1);
	             str = Double.toString(Math.round(c[i].imag*10000)/10000.0);
	             tableData.setValueAt(str, i, 2);
	        }
	 }
	 
	 void tbDegreInp_TextChanged()
     {
		 n = Integer.parseInt(tbN.getText());
         if (tbDegreInp.getText() != "")
         {
             double tempD = Double.parseDouble(tbDegreInp.getText());
             if ((tempD >= 0) && (tempD < 180.0))
             {
                 alpha = tempD * Math.PI / 180.0;
                 SelectionChanged();
             }
         }
     }

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					mainFrame window = new mainFrame();
					window.frmFourierSignals.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public mainFrame() {
		int i;
		initialize();
		tbDegreInp.setVisible(false);
		tbN.setVisible(false);
		lAlpha.setVisible(false);
		lNInput.setVisible(false);
		tbDegreInp.setText(Double.toString(Math.round(alpha / Math.PI * 180.0)));
		tbN.setText(Integer.toString(n));
		w = new TComplex[order];
        y = new TComplex[order];
        c = new TComplex[order];
        for (i = 0; i < order; i++)
        {
        	w[i] = new TComplex();
            y[i] = new TComplex();
            c[i] = new TComplex();
        }
        Rectangle(peak, alpha, n);  
        for (i = 0; i < 30; i++)        // put values into the DataGrid
        {
        	 String str = Integer.toString(i);
             tableData.setValueAt(str, i, 0);
             str = Double.toString(Math.round(c[i].real*10000)/10000.0);
             tableData.setValueAt(str, i, 1);
             str = Double.toString(Math.round(c[i].imag*10000)/10000.0);
             tableData.setValueAt(str, i, 2);
        }
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmFourierSignals = new JFrame();
		frmFourierSignals.setTitle("Fourier signals");
		frmFourierSignals.setIconImage(Toolkit.getDefaultToolkit().getImage(mainFrame.class.getResource("/Ressource/Icon.png")));
		frmFourierSignals.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmFourierSignals.setBounds(100, 100, 659, 618);
		frmFourierSignals.getContentPane().setLayout(null);
		pGraph = new JPanel();
		final Canvas canvas = new myCanvas();
		canvas.setBackground(Color.WHITE);
		pGraph.addComponentListener(new ComponentAdapter() {
			@Override
			public void componentResized(ComponentEvent arg0) {
				canvas.setBounds(0, 0, pGraph.getWidth(), pGraph.getHeight());
			}
		});
		pGraph.setBackground(Color.WHITE);
		pGraph.setBounds(10, 11, 620, 329);
		frmFourierSignals.getContentPane().add(pGraph);
		pGraph.add(canvas);
		pGraph.setLayout(null);
		
		tableData = new TDataGrid(3, 30); 
		tDataTable = new JTable(tableData);
		tDataTable.setRowHeight(25);
		tDataTable.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		tDataTable.setFont(new Font("Tahoma", Font.PLAIN, 14));
		tDataTable.setBounds(10, 11, 477, 750);
		frmFourierSignals.getContentPane().add(tDataTable);
		JScrollPane scroll = new JScrollPane(tDataTable);
	    scroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		frmFourierSignals.getContentPane().add(scroll);
	    scroll.setBounds(10, 351, 444, 218);
	    
	    String[] elements= {"Rectangle","Triangle","Sawtooth","SinusRectifiedCut","SinusCut","Pwm","Ask","Fsk","Psk270","Psk180","Psk90"};
	    comboBox = new JComboBox(elements);
	    comboBox.addItemListener(new ItemListener() {
	    	public void itemStateChanged(ItemEvent e) {
	    		SelectionChanged();
	    		canvas.repaint();
	    	}
	    });
	    comboBox.setBounds(495, 351, 135, 22);
	    frmFourierSignals.getContentPane().add(comboBox);
	    
	    tbDegreInp = new JTextField();
	    tbDegreInp.addKeyListener(new KeyAdapter() {
	    	@Override
	    	public void keyReleased(KeyEvent e) {
	    		tbDegreInp_TextChanged();
	    		canvas.repaint();
	    	}
	    });
	    
	    tbDegreInp.setColumns(10);
	    tbDegreInp.setBounds(568, 384, 62, 30);
	    frmFourierSignals.getContentPane().add(tbDegreInp);
	    
	    tbN = new JTextField();
	    tbN.addKeyListener(new KeyAdapter() {
	    	@Override
	    	public void keyReleased(KeyEvent e) {
	    		tbDegreInp_TextChanged();
	    		canvas.repaint();
	    	}
	    });
	    tbN.setColumns(10);
	    tbN.setBounds(568, 425, 62, 30);
	    frmFourierSignals.getContentPane().add(tbN);
	    
	    lAlpha = new JLabel("alpha");
	    lAlpha.setFont(new Font("Tahoma", Font.PLAIN, 14));
	    lAlpha.setBounds(515, 392, 46, 14);
	    frmFourierSignals.getContentPane().add(lAlpha);
	    
	    lNInput = new JLabel("n");
	    lNInput.setFont(new Font("Tahoma", Font.PLAIN, 14));
	    lNInput.setBounds(515, 433, 46, 14);
	    frmFourierSignals.getContentPane().add(lNInput);
	    TableColumnModel columnModel = tDataTable.getColumnModel();
	    columnModel.getColumn(0).setHeaderValue("order");
	    columnModel.getColumn(1).setHeaderValue("Real");
	    columnModel.getColumn(2).setHeaderValue("Im");
	}
}
